#include <avr/io.h>// /
#include <avr/interrupt.h>// 
#include <util/delay.h>
#include "main_init.h"
#include "dht.c"
#include "axlib/lcd.h"
#include "i2c_slave.h"


#define I2C_ADDR 0x32
#define txbuffer_crc() {txbuffer[6]=txbuffer[0]+txbuffer[1]+txbuffer[2]+txbuffer[3]+txbuffer[4]+txbuffer[5];}

/*
:

PD2   .
PD3 - co2 (  int ?)
PD4 - dht
PC4 SDA
PC5 SCL

LCD
D6 - RS
D7 - E
B0 - data0
B1 - data1
B2 - data2
B3 - data3
B4   
*/
/*
txbuffer[0] - co2(hi)
txbuffer[1] - co2(lo)
txbuffer[2] - t
txbuffer[3] - h
txbuffer[4] - time from start (0xfe  )
txbuffer[5] -     co2 (  ,    4 .)
txbuffer[6]    .
*/

#define PIN_CO2 (PIND&0b1000)
#define msc(x) ((x)/((F_CPU/1024.0)/1000.0)) //    
#define external_calibrate_co2(x) ((x)*1) //      400

//char co2_read_cmd[9]={0xFF, 0x01, 0x86, 0x00, 0x00, 0x00, 0x00, 0x00, 0x79};
//char co2_read_cmd[9]={0xFF, 0x01, 0x88, 0x07, 0xD0, 0x00, 0x00, 0x00, 0xA0}; //calibrate
//char co2_reply[9];
unsigned int co2=0;
unsigned int co2_th=0, co2_tl=0;

void main(void){
char buf[7];
float temp=0, hum=0;
char from_start=0;
char cik=0;//    I2C.
int i, ms_l, ms_h;

EIMSK |= (1 << INT1);
EICRA |= (1 << ISC10)+(1 << ISC11);//  .
TCCR1B |=(1<<CS10)|(1<<CS12); //    1024.


DDRB|=0b100000;
PORTB|=0b100000;

dht_init(4);

//
//DDRB|=0b10000;
//PORTB|=0b10000;
lcd_init(0);
//I2C_init(I2C_ADDR);


sei();

/*for (i=0;i<60;i++)_delay_ms(1000);
PORTD&=~0x10;
for (i=0;i<15;i++)_delay_ms(1000);
PORTD|=0x10;*/


txbuffer[0]=txbuffer[1]=txbuffer[2]=txbuffer[3]=txbuffer[4]=txbuffer[5]=txbuffer[6]=0;

while(1)
	{
	
	dht_read_data (4, &temp, &hum);
	//for(i=0;i<8;i++)co2_reply[i]=SUART_GetChar();

	ms_l=msc(co2_tl);
	ms_h=msc(co2_th);
	if(((ms_l+ms_h)>975)&&((ms_l+ms_h)<1025))//   ,    -  .
		{
		txbuffer[5]=0;
		txbuffer_crc();
		co2=external_calibrate_co2(2000*(msc(co2_th)-2)/(msc(co2_th+co2_tl)-4));// 
		}
	else if (txbuffer[5]!=0xff){
    txbuffer[5]++;
    txbuffer_crc();
    }
	
	sprintf(buf, "H%2d T%2d",  (int)hum, (int)temp);
	//sprintf(buf, "%3d %3d",  (int)txbuffer[4], (int)txbuffer[5]);
	lcd_gotoxy(0,0);
	lcd_str_out(buf);
	//co2=co2_reply[2]*256+co2_reply[1];
	//sprintf(buf, "%2x%2x%2x%2x", co2_reply[0], co2_reply[1], co2_reply[2], co2_reply[3]);
	//lcd_gotoxy(0,0);
	//lcd_str_out(buf);
	//sprintf(buf, "%2x%2x%2x%2x", co2_reply[4], co2_reply[5], co2_reply[6], co2_reply[7]);
	sprintf(buf, "CO2:%4u", co2 );
	lcd_gotoxy(0,1);
	lcd_str_out(buf);

	EIMSK |= (1 << INT1);
	
	cli();
	txbuffer[0]=(unsigned char) (co2>>8);
	txbuffer[1]=(unsigned char) (co2&0xff);
	txbuffer[2]=(unsigned char)temp;
	txbuffer[3]=(unsigned char)hum;
	if(txbuffer[4]<250)
	txbuffer[4]++;// 
	else txbuffer[4]=0xfe;
	txbuffer_crc();
	sei();
	
	if(!(cik&0x3)) //  4   I2C.    , -.
		{
		I2C_stop();
		I2C_init(I2C_ADDR);
		}
	cik++;

/*
//     . 
	hum++;
	if(hum==500)
		{
		DDRD|=0b100;
		PORTD&=~0b100;
		for (i=0;i<15;i++)_delay_ms(1000);
		DDRD&=~0b100;
		}
*/
	_delay_ms(1000);
	}

}


ISR(INT1_vect)
{
static char in_calc=0;//0 -      , 1  .
if(EICRA&(1 << ISC10))//     ,     .
	{
	if(!in_calc)
		{//  
		TCNT1=0;
		EICRA &= ~(1 << ISC10);//      
		in_calc=1;
		return;
		}
	else
		{//  
		EIMSK &= ~(1 << INT1);//    
		co2_tl=TCNT1;
		in_calc=0;
		return;
		}

	}
else //   ,     
	{
	co2_th=TCNT1;
	TCNT1=0;	
	EICRA |= (1 << ISC10);//       
	return;
	}
}
